/*
 * Copyright 2008 Evan Cowden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */
package org.nakedosgi.annotations.scr;

/**
 * Specifies a properties file.  Note that this maps to the <i>properties</i>
 * element in the SCR specification, and that the {@link Properties} annotation
 * maps multiply {@link Property} annotations.
 * @author Evan Cowden
 */
public @interface SCRPropertiesFile {

    /**
     * Specifies the properties file.  Maps to the <i>entry</i> attribute.
     * @return
     */
    String value();
}
