/*
 * Copyright 2007 Evan Cowden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */
package org.nakedosgi.manifest;

/**
 * Constant values for creating a MANIFEST.MF file.
 */
public interface ManifestConstants {

    public static final String MANIFEST_FILE = "META-INF/MANIFEST.MF";
    /**
     * Filename for the temporary manifest file created by the annotation 
     * processor
     */
    public static final String TEMP_MANIFEST_FILE = MANIFEST_FILE + ".Naked-OSGi";
    public static final String MANIFEST_VERSION_KEY = "Manifest-Version";
    public static final String MANIFEST_VERSION_DEFAULT = "1.0";
    public static final String BUNDLE_MANIFEST_VERSION_KEY = "Bundle-ManifestVersion";
    public static final String BUNDLE_MANIFEST_VERSION_DEFAULT = "2";
    public static final String BUNDLE_NAME_KEY = "Bundle-Name";
    public static final String BUNDLE_SYMBOLIC_NAME_KEY = "Bundle-SymbolicName";
    public static final String BUNDLE_VERSION_KEY = "Bundle-Version";
    public static final String BUNDLE_VERSION_DEFAULT = "1.0.0";
    public static final String EXPORT_PACKAGE_KEY = "Export-Package";
    public static final String IMPORT_PACKAGE_KEY = "Import-Package";
    /**
     * Key string for a declaritive services Service-Component definition
     */
    public static final String SERVICE_COMPONENT_KEY = "Service-Component";
    /**
     * Key string for an OSGi Bundle Activator definition
     */
    public static final String BUNDLE_ACTIVATOR_KEY = "Bundle-Activator";
    /**
     * Seperator for items in lists of values
     */
    public static final String MANIFEST_SEPERATOR = ",";
}
