/*
 * Copyright 2008 Evan Cowden
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */
package org.nakedosgi.processor.model;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

/**
 * <p>Java class for Service complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Service">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="provide" type="{http://www.osgi.org/xmlns/scr/v1.0.0}Provide" maxOccurs="unbounded"/>
 *       &lt;/sequence>
 *       &lt;attribute name="servicefactory" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Tservice", propOrder = {
"provide"
})
public class Service {

    @XmlElement(required = true)
    protected List<Provide> provide;
    @XmlAttribute
    protected Boolean servicefactory;

    /**
     * Gets the value of the provide property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the provide property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getProvide().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Provide }
     * 
     * 
     */
    public List<Provide> getProvide() {
        if (provide == null) {
            provide = new ArrayList<Provide>();
        }
        return this.provide;
    }

    /**
     * Gets the value of the servicefactory property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isServicefactory() {
        if (servicefactory == null) {
            return false;
        } else {
            return servicefactory;
        }
    }

    /**
     * Sets the value of the servicefactory property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setServicefactory(Boolean value) {
        this.servicefactory = value;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Service other = (Service) obj;
        if (this.provide != other.provide && (this.provide == null || !this.provide.equals(other.provide))) {
            return false;
        }
        if (this.servicefactory != other.servicefactory && (this.servicefactory == null || !this.servicefactory.equals(other.servicefactory))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + (this.provide != null ? this.provide.hashCode() : 0);
        hash = 97 * hash + (this.servicefactory != null ? this.servicefactory.hashCode() : 0);
        return hash;
    }
}
